Loading...
Searching...
No Matches
OdbcFirebirdSqlUtil::OdbcFirebirdTable Class Reference

provides the OdbcFirebird-specific implementation of the AbstractTable interface More...

Inherits SqlUtil::AbstractTable.

## Public Member Functions

private | doSelectOrderByWithOffsetSqlUnlockedImpl (reference< hash< QueryInfo > > info, reference< string > sql, list< auto > coll)
| processes a string for use in SQL select statements when there is an "order by" and "offset" argument
string | getColumnSqlName (string col)
| returns the column name for use in SQL strings; subclasses can return a special string in case the column name is a reserved word More...
list< string > | getColumnSqlNames (softlist< auto > cols)
| returns a list of column names for use in SQL strings; subclasses can process the argument list in case a column name is a reserved word
string | getSqlName ()
| returns the name of the table to be used in SQL (with a possible qualifiers for schema, etc)
bool | hasArrayBind ()
| returns False because the odbcfirebird driver does not support array binds / bulk DML
bool | hasReturningImpl ()
| returns True if the current database driver supports the `"returning"` clause in insert statements, False if not

## Static Public Member Functions

static *string | getSqlValue (auto v)
| returns a string for use in SQL queries representing the DB-specific value of the argument More...

## Public Attributes

const | OdbcFirebirdCopMap = ...
| column operator specializations for OdbcFirebird
const | OdbcFirebirdTypeMap
| maps odbcfirebird type names to type configurations
const | QoreTypeMap = ...
| maps qore type names to OdbcFirebird type names

## Protected Member Functions

bool | asteriskRequiresPrefix ()
| returns True if the database requires a wildcard `"*"` to be prefixed with the table name when it appears with other column arguments in a select statement
bool | constraintsLinkedToIndexesImpl ()
| returns True if the database links constraints to indexes (ie dropping the constraint drops the index, etc)
| copyImpl (AbstractTable old)
| db-specific copy actions
| doSelectLimitOnlyUnlockedImpl (reference< hash< QueryInfo > > info, reference< string > sql)
| processes a string for use in SQL select statements when there is a "limit" argument, but no "orderby" or "offset" arguments
hash | getColumnOperatorMapImpl ()
| returns the column operator map for this object
AbstractDataProviderType | getNumericTypeImpl (string native_type, bool nullable, *hash< auto > options)
| returns the type for number / numeric columns for the database so that data conversions can be handled
AbstractSavepointHelper | getSavepointHelperImpl (*string savepoint)
| get DB-specific savepoint helper More...
*string | getSqlValueImpl (auto v)
| returns a string for use in SQL queries representing the DB-specific value of the argument More...
bool | isDuplicateRowErrorImpl (hash< ExceptionInfo > ex)
| Returns True if the exception was raised because of a duplicate row / key error. More...
bool | supportsTablespacesImpl ()
| returns True if the database support tablespaces
bool | uniqueIndexCreatesConstraintImpl ()
| returns True if the database automatically creates a unique constraint when a unique index is created (ex: odbcfirebird)

## Static Protected Member Functions

static *string | getSqlValueIntern (auto v)
| returns a string for use in SQL queries representing the DB-specific value of the argument More...

## Detailed Description

provides the OdbcFirebird-specific implementation of the AbstractTable interface

## Member Function Documentation

## getColumnSqlName()

string OdbcFirebirdSqlUtil::OdbcFirebirdTable::getColumnSqlName | ( | string | col | ) |

returns the column name for use in SQL strings; subclasses can return a special string in case the column name is a reserved word

OdbcFirebird/MariaDB etc require column names to be enclosed in backticks instead of double quotes

## getSavepointHelperImpl()

AbstractSavepointHelper OdbcFirebirdSqlUtil::OdbcFirebirdTable::getSavepointHelperImpl | ( | *string | savepoint | ) |

protected

get DB-specific savepoint helper

Parameters

  savepoint | the savepoint string, if not given a unique savepoint string will be generated

Since
  SqlUtil 1.6

## getSqlValue()

static *string OdbcFirebirdSqlUtil::OdbcFirebirdTable::getSqlValue | ( | auto | v | ) |

static

returns a string for use in SQL queries representing the DB-specific value of the argument

Example:
  string str = table.getSqlValue(date);

Parameters

  v | the value to convert to an SQL value

Returns
  a string representing the value usable in SQL strings for the given database driver

Exceptions

  VALUE-ERROR | the given value cannot be converted to an SQL string (missing rules for value)

## getSqlValueImpl()

*string OdbcFirebirdSqlUtil::OdbcFirebirdTable::getSqlValueImpl | ( | auto | v | ) |

protected

returns a string for use in SQL queries representing the DB-specific value of the argument

returns NOTHING if the type cannot be converted to an SQL string

## getSqlValueIntern()

static *string OdbcFirebirdSqlUtil::OdbcFirebirdTable::getSqlValueIntern | ( | auto | v | ) |

static protected

returns a string for use in SQL queries representing the DB-specific value of the argument

returns NOTHING if the type cannot be converted to an SQL string

## isDuplicateRowErrorImpl()

bool OdbcFirebirdSqlUtil::OdbcFirebirdTable::isDuplicateRowErrorImpl | ( | hash< ExceptionInfo > | ex | ) |

protected

Returns True if the exception was raised because of a duplicate row / key error.

Since
  OdbcFirebirdSqlUtil 1.4.2